package espresso;

class Env implements Constants {
   boolean isSelfCall;
   boolean isStatic;
   TypSet reported;
   Scope importScope;
   Scope globalScope;
   Scope scope;
   Name packageName;
   ClassDef enclClass;
   FunDef enclMeth;
   FunDef enclFun;
   TopLevel toplevel;
   AST parent;
   Env next;

   boolean isInterface() {
      return this.parent.tag == 16 && (this.enclClass.mods & 512) != 0;
   }

   Env(Env var1, AST var2, Scope var3) {
      this(var1, var2);
      this.scope = var3;
   }

   Env(Env var1, AST var2) {
      this.next = var1;
      this.parent = var2;
      this.toplevel = var1.toplevel;
      this.enclFun = var1.enclFun;
      this.enclMeth = var1.enclMeth;
      this.enclClass = var1.enclClass;
      this.packageName = var1.packageName;
      this.scope = var1.scope;
      this.globalScope = var1.globalScope;
      this.importScope = var1.importScope;
      this.reported = var1.reported;
      this.isStatic = var1.isStatic;
      this.isSelfCall = var1.isSelfCall;
   }

   Env(TopLevel var1) {
      this.next = null;
      this.parent = var1;
      this.toplevel = var1;
      this.enclFun = null;
      this.enclMeth = null;
      this.enclClass = null;
      this.packageName = Name.fromString("");
      this.scope = new Scope((Scope)null, (Obj)null);
      this.globalScope = this.scope;
      this.importScope = new Scope((Scope)null, (Obj)null);
      this.reported = null;
      this.isStatic = false;
      this.isSelfCall = false;
   }
}
