package espresso;

class Return extends Jump {
   AST enclBlock;
   AST expr;

   void print(int var1) {
      System.out.print("return ");
      if (this.expr != null) {
         this.expr.print();
      }

   }

   Item gen() {
      Gen.statBegin(super.pos);
      ((Jump)this).finalisation();
      if (this.expr != null) {
         Typ var1;
         if (this.enclBlock.tag == 15) {
            var1 = this.enclBlock.typ;
         } else {
            var1 = ((FunTyp)((FunDef)this.enclBlock).obj.typ).restyp;
         }

         this.expr.gen().coerce(this.expr.typ, var1).load(var1);
         if (this.enclBlock.tag == 15) {
            Sequence var2 = (Sequence)this.enclBlock;
            var2.retLab = Gen.mergeLabels(var2.retLab, Gen.branch(167));
         } else {
            Gen.emitop(172 + Gen.typecode(var1));
         }
      } else {
         Gen.emitop(177);
      }

      return Item.voidItem;
   }

   AST simplify() {
      if (this.expr != null) {
         this.expr = this.expr.simplify();
      }

      return this;
   }

   void markCaptured(Bits var1) {
      if (this.expr != null) {
         this.expr.markCaptured(var1);
      }

      super.markCaptured(var1);
      var1.clear();
   }

   Typ attr(Env var1, int var2, Typ var3) {
      Env var4;
      for(var4 = var1; var4 != null && var4.parent.tag != 65 && var4.parent.tag != 67 && var4.parent.tag != 15; var4 = var4.next) {
         if (var4.parent.tag == 18) {
            super.finalizers.addElement(var4.parent);
         }
      }

      if (var4 != null) {
         this.enclBlock = var4.parent;
         if (var3.tag == 12) {
            if (this.expr == null) {
               super.typ = var3;
            } else {
               Report.error(this.expr.pos, "can't return a value from function whose result type is void");
               super.typ = Typ.errTyp;
            }
         } else if (this.expr == null) {
            Report.error(super.pos, "missing return value");
            super.typ = Typ.errTyp;
         } else {
            super.typ = this.expr.attr(var1, 12, var3);
         }
      } else {
         Report.error(super.pos, "static initializer cannot return");
         super.typ = Typ.errTyp;
      }

      return super.typ;
   }

   Return(int var1, AST var2) {
      super(var1, 12);
      this.expr = var2;
   }
}
