package espresso;

class Typeop extends AST {
   AST dcltyp;
   AST expr;

   void print(int var1) {
      Pretty.open(var1, 10);
      if (super.tag == 62) {
         System.out.print("(");
         this.dcltyp.print(11);
         System.out.print(")");
         this.expr.print(11);
      } else {
         this.expr.print(10);
         System.out.print(" instanceof ");
         this.dcltyp.print();
      }

      Pretty.close(var1, 10);
   }

   Item gen() {
      Item var1 = this.expr.gen();
      if (super.tag == 62) {
         return var1.coerce(this.expr.typ, this.dcltyp.typ);
      } else {
         var1.load(this.expr.typ);
         Gen.emitop2(193, Gen.mkref(this.dcltyp.typ));
         return Item.stackItem;
      }
   }

   AST simplify() {
      this.expr = this.expr.simplify();
      this.dcltyp = this.dcltyp.simplify();
      return this;
   }

   void markCaptured(Bits var1) {
      this.expr.markCaptured(var1);
   }

   Typ attr(Env var1, int var2, Typ var3) {
      if (Attr.checkKind(super.pos, 12, var2)) {
         Typ var4 = this.expr.attr(var1, 12, Typ.anyTyp);
         Typ var5 = Attr.checkNonVoid(this.dcltyp.pos, this.dcltyp.attr(var1, 2, Typ.anyTyp));
         if (super.tag == 62) {
            if (Attr.canCast(var4, var5)) {
               super.typ = Attr.checkTyp(super.pos, var5, var3);
            } else {
               Report.error(super.pos, String.valueOf(String.valueOf(String.valueOf("cannot cast ").concat(String.valueOf(var4))).concat(String.valueOf(" to "))).concat(String.valueOf(var5)));
               super.typ = Typ.errTyp;
            }
         } else if (!Attr.canCast(var4, var5) || var5.tag != 13 && var5.tag != 11) {
            Report.error(super.pos, String.valueOf(String.valueOf(String.valueOf("cannot compare ").concat(String.valueOf(var4))).concat(String.valueOf(" with "))).concat(String.valueOf(var5)));
            super.typ = Typ.errTyp;
         } else {
            super.typ = Attr.checkTyp(super.pos, Typ.booleanTyp, var3);
         }
      } else {
         super.typ = Typ.errTyp;
      }

      return super.typ;
   }

   boolean isConstant() {
      return super.tag == 62 && this.expr.isConstant();
   }

   boolean isExpr() {
      return true;
   }

   Typeop(int var1, int var2, AST var3, AST var4) {
      super(var1, var2);
      this.expr = var3;
      this.dcltyp = var4;
   }
}
